package com.gic.haoban.manage.service.dao.mapper;

import com.gic.haoban.manage.service.entity.TabHaobanExternalClerkRelated;
import com.gic.haoban.manage.service.entity.TabHaobanWxEnterprise;
import com.github.pagehelper.Page;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.Date;
import java.util.List;

public interface TabHaobanExternalClerkRelatedMapper {
    int deleteByPrimaryKey(String externalClerkRelatedId);

    int insertSelective(TabHaobanExternalClerkRelated record);

    TabHaobanExternalClerkRelated selectByPrimaryKey(String externalClerkRelatedId);

    int updateByPrimaryKeySelective(TabHaobanExternalClerkRelated record);

    TabHaobanExternalClerkRelated selectByClerkIdAndExternalUserId(@Param("clerkId") String clerkId, @Param("externalUserId") String externalUserId);

    void delByUserIdAndExternalUserId(TabHaobanExternalClerkRelated record);

    void delByUserIdAndExternalUserIdBatch(@Param("wxUserId") String wxUserId, @Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserIds") List<String> externalUserIds);

    void delByClerkIdAndStaffId(@Param("clerkId") String clerkId, @Param("staffId") String staffId);

    void delByStoreIdAndStaffId(@Param("storeId") String storeId, @Param("staffId") String staffId);

    int delByStoreIds(@Param("storeIds") Collection<String> storeIds);

    void cleanStaffRelated(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("staffIds") List<String> staffIds);

    TabHaobanExternalClerkRelated getByParams(@Param("userId") String userId, @Param("wxEnterpriseId") String wxEnterpriseId, @Param("name") String name, @Param("createTime") String createTime);

    List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserId(@Param("externalUserid") String externalUserid, @Param("userId") String wxUserId);

    /**
     * 查询该会员该企业下的好友关系
     *
     * @param externalUserid 外部用户标识
     * @param wxEnterpriseId wx企业标识
     * @param statusFlags    状态标志
     * @return {@link List<TabHaobanExternalClerkRelated> }
     * @author mozhu
     * @date 2022-02-10 10:11:21
     */
    List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxEnterpriseId(@Param("externalUserid") String externalUserid,
                                                                              @Param("wxEnterpriseId") String wxEnterpriseId,
                                                                              @Param("statusFlags") List<String> statusFlags);

    List<TabHaobanExternalClerkRelated> listByExTernalUseridAndWxUserIdAllStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserid") String externalUserid, @Param("userId") String wxUserId);

    List<TabHaobanExternalClerkRelated> listByEnterpriseIdAndDate(@Param("enterpriseId") String enterpriseId, @Param("date") Date date);

    Page<TabHaobanExternalClerkRelated> pageMemberUnionByParams(@Param("userIdList") List<String> userIdList, @Param("sendMemberIds") List<String> sendMemberIds,
                                                                @Param("enterpriseId") String enterpriseId);

    List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserId(@Param("wxUserId") String wxUserId, @Param("wxEnterpriseId") String wxEnterpriseId);

    List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserIds(@Param("userIdList") List<String> userIdList, @Param("wxEnterpriseId") String wxEnterpriseId);

    TabHaobanExternalClerkRelated getByMemberId(@Param("wxUserId") String wxUserId, @Param("memberId") String memberId);

    /**
     * 外部联系人的unionid
     *
     * @param enterpriseId
     * @param unionId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listExternalByUnionId(@Param("enterpriseId") String enterpriseId, @Param("unionId") String unionId);

    /**
     * 外部联系人的unionid
     *
     * @param enterpriseId
     * @param unionId
     * @return
     */
    TabHaobanExternalClerkRelated getClerkExternalByUnionId(@Param("enterpriseId") String enterpriseId, @Param("clerkId") String clerkId, @Param("unionId") String unionId);

    /**
     * @param relationKey
     * @return
     */
    TabHaobanExternalClerkRelated getByRelationKey(@Param("relationKey") String relationKey);

    /**
     * 列表数据 根据状态 时间倒序
     *
     * @param wxEnterpriseId
     * @param wxUserId
     * @param statusFlags
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByWxEnterpriseIdAndWxUserIdAndStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("wxUserId") String wxUserId, @Param("statusFlags") List<Integer> statusFlags);

    /**
     * 触达会员 给会员发送
     *
     * @param relationKey
     * @return
     */
    int pushExternalByRelationKey(@Param("relationKey") String relationKey);

    /**
     * 获取企业下的关联关系列表
     *
     * @param wxEnterpriseId
     * @param wxUserId
     * @param enterpriseId
     * @param externalUserId
     * @return
     */
    TabHaobanExternalClerkRelated getExternalClerkByWxUserIdAncExternalUserId(@Param("wxEnterpriseId") String wxEnterpriseId,
                                                                              @Param("wxUserId") String wxUserId,
                                                                              @Param("enterpriseId") String enterpriseId,
                                                                              @Param("externalUserId") String externalUserId);

    /**
     * 查询会员在企业下的好友关系
     *
     * @param memberId
     * @param wxEnterpriseId
     * @param enterpriseId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByMemberIdAndWxEnterpriseId(@Param("memberId") String memberId,
                                                                        @Param("wxEnterpriseId") String wxEnterpriseId,
                                                                        @Param("enterpriseId") String enterpriseId);

    /**
     * 查询会员在企业下的好友关系
     *
     * @param wxUserId
     * @param wxEnterpriseId
     * @param enterpriseId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByWxUserIdAndWxEnterpriseId(@Param("wxUserId") String wxUserId,
                                                                        @Param("wxEnterpriseId") String wxEnterpriseId,
                                                                        @Param("enterpriseId") String enterpriseId);

    /**
     * 获取最新的最近的外部联系人
     *
     * @param externalUserid
     * @param wxUserId
     * @return
     */
    TabHaobanExternalClerkRelated getLastByExTernalUseridAndWxUserIdNoStatus(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("externalUserid") String externalUserid, @Param("wxUserId") String wxUserId);

    /**
     * 根据id 查询列表
     *
     * @param wxEnterpriseId
     * @param ids
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByIds(@Param("wxEnterpriseId") String wxEnterpriseId,
                                                  @Param("ids") List<String> ids);

    /**
     * 根据企业id 查询列表
     *
     * @param wxEnterpriseId
     * @return
     */
    List<String> listMemberIdByEnterpriseId(@Param("wxEnterpriseId") String wxEnterpriseId,
                                            @Param("enterpriseId") String enterpriseId);

    /**
     * 查询会员在企业下的好友关系 根据会员ids
     *
     * @param memberIds
     * @param wxEnterpriseId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByMemberIds(@Param("memberIds") List<String> memberIds,
                                                        @Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * 查询会员在企业下的好友关系memberIds 根据会员ids
     *
     * @param memberIds
     * @param wxEnterpriseId
     * @return
     */
    List<String> listMemberIdsByMemberIds(@Param("memberIds") List<String> memberIds,
                                          @Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * 查询会员在企业下的好友关系 根据会员id
     * @param memberId
     * @param enterpriseId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByMemberId(@Param("memberId") String memberId,
                                                       @Param("enterpriseId") String enterpriseId);

    /**
     * 查询会员在企业下的好友关系 根据会员id
     *
     * @param wxEnterpriseId
     * @return
     */
    List<TabHaobanExternalClerkRelated> listByExternalUserId(@Param("wxEnterpriseId") String wxEnterpriseId,
                                                             @Param("externalUserId") String externalUserId);

    /**
     * 根据会员id更新新老会员id
     *
     * @param memberId
     * @param oldMemberId  老会员id
     * @param enterpriseId 企业标识
     * @return int
     * @author mozhu
     * @date 2022-03-24 10:28:40
     */
    int updateMemberIdByMemberId(@Param("memberId") String memberId,
                                 @Param("oldMemberId") String oldMemberId,
                                 @Param("enterpriseId") String enterpriseId);

    /**
     * 更新状态通过会员id
     *
     * @param memberId     会员ID
     * @param enterpriseId 企业id
     * @return int
     * @author mozhu
     * @date 2021-09-13 16:59:49
     */
    int updateStatusByMemberId(@Param("memberId") String memberId, @Param("enterpriseId") String enterpriseId);


    /**
     * 通过会员id和员工id查询数据
     *
     * @param staffId      员工id
     * @param enterpriseId 企业标识
     * @param memberId     会员ID
     * @return {@link TabHaobanExternalClerkRelated }
     * @author mozhu
     * @date 2021-10-21 10:41:28
     */
    TabHaobanExternalClerkRelated getByMemberIdAndStaffId(@Param("staffId") String staffId,
                                                          @Param("enterpriseId") String enterpriseId,
                                                          @Param("memberId") String memberId);

    /**
     * 根据企业id分页
     *
     * @param wxEnterpriseId 企业标识
     * @return {@link List<TabHaobanWxEnterprise> }
     * @author mozhu
     * @date 2021-12-13 14:59:03
     */
    List<TabHaobanExternalClerkRelated> pageExternalByEnterpriseId(@Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * 更新外部用户id的老外部用户id
     *
     * @param newExternalUserId 外部用户id
     * @param oldExternalUserId 旧的外部用户id
     * @param wxEnterpriseId    wx企业标识
     * @return int
     * @author mozhu
     * @date 2021-12-13 15:33:41
     */
    int updateExternalUserIdByOldExternalUserId(@Param("newExternalUserId") String newExternalUserId,
                                                @Param("oldExternalUserId") String oldExternalUserId,
                                                @Param("wxEnterpriseId") String wxEnterpriseId);

    /**
     * 获取好友数量
     *
     * @param wxEnterpriseId 企业id
     * @param enterpriseId   商户id
     * @param wxUserId       企业微信导购账号
     * @param clerkId        导购id
     * @return
     */
    int countByClerkId(@Param("wxEnterpriseId") String wxEnterpriseId,
                       @Param("enterpriseId") String enterpriseId,
                       @Param("wxUserId") String wxUserId,
                       @Param("clerkId") String clerkId);

    /**
     * 客户好友需触达列表
     *
     * @param wxEnterpriseId wx企业标识
     * @param wxUserId       wx用户id
     * @param enterpriseId
     * @param externalUserId
     * @return {@link TabHaobanExternalClerkRelated }
     * @author mozhu
     * @date 2022-02-11 14:15:25
     */
    TabHaobanExternalClerkRelated getByEnterpriseIdAndExternalUserId(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("wxUserId") String wxUserId,
                                                                     @Param("enterpriseId") String enterpriseId, @Param("externalUserId") String externalUserId);


    /**
     * 查询所有好友关系
     *
     * @param wxEnterpriseId wx企业标识
     * @param wxUserId       wx用户id
     * @return {@link List}<{@link TabHaobanExternalClerkRelated}>
     */
    List<TabHaobanExternalClerkRelated> getByWxUserIdAndWxEnterpriseId(@Param("wxEnterpriseId") String wxEnterpriseId, @Param("wxUserId") String wxUserId);


    /**
     * 根据wxuserid和会员unionid进行查询数据
     *
     * @param wxEnterpriseId wx企业标识
     * @param wxUserId       wx用户id
     * @param unionid        unionid
     * @return {@link TabHaobanExternalClerkRelated }
     * @author mozhu
     * @date 2022-03-11 15:21:15
     */
    TabHaobanExternalClerkRelated getByWxEnterpriseIdAndUnionId(@Param("wxEnterpriseId") String wxEnterpriseId,
                                                                     @Param("wxUserId") String wxUserId,
                                                                     @Param("unionid") String unionid);


    /**
     * 查询最新的会员好友
     *
     * @param enterpriseId 企业标识
     * @param memberId     成员身份
     * @param statusFlag   状态标志
     * @return {@link TabHaobanExternalClerkRelated }
     * @author mozhu
     * @date 2022-04-15 17:12:38
     */
    TabHaobanExternalClerkRelated getByEnterpriseIdAndMemberId(@Param("enterpriseId") String enterpriseId,
                                                                @Param("memberId") String memberId,
                                                               @Param("statusFlag") Integer statusFlag);

    /**
     * 会员好友数量
     *
     * @param memberId     成员身份
     * @param enterpriseId 企业标识
     * @return int
     * @author mozhu
     * @date 2022-04-21 10:06:21
     */
    int countByMemberId(@Param("memberId") String memberId,
                        @Param("enterpriseId") String enterpriseId);
}